Bizzare = {}
Bizzare.Air = E_BLOCK_AIR
Bizzare.Block = E_BLOCK_WOOL
Bizzare.BlockMeta = E_META_WOOL_RED
Bizzare.World = {}
Bizzare.Map = {}
Bizzare.MapNext = {}

Settings = {}
Settings.LiveMinimum = 2
Settings.LiveMaximum = 7
Settings.Birth = 5
Settings.TicksPerUpdate = 10

TickCounter = 0
NextUpdateTick = 0

UpdateDelay = 1
--|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
function Initialize( Plugin )
	PLUGIN = Plugin
	PLUGIN:SetName( "Bizzare" )
	PLUGIN:SetVersion( 100500 )
	
	cPluginManager:AddHook( cPluginManager.HOOK_TICK, OnTick )
	cPluginManager:AddHook( cPluginManager.HOOK_PLAYER_PLACED_BLOCK, OnPlayerPlacedBlock )
	cPluginManager:AddHook( cPluginManager.HOOK_PLAYER_BROKEN_BLOCK, OnPlayerBrokenBlock )
	
	LoadSettings()
	NextUpdateTick = Settings.TicksPerUpdate
	LOG( "Initialized "..PLUGIN:GetName().." v"..PLUGIN:GetVersion() )
	return true
end

function OnDisable()
	SaveSettings()
	LOG( PLUGIN:GetName().." v"..PLUGIN:GetVersion().." is shutting down..." )
end
--|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
function OnTick()
	TickCounter = TickCounter + 1
	if( TickCounter == NextUpdateTick ) then
		LOGINFO( "Bizzare: brace yourselves, Update() is coming" )
		NextUpdateTick = NextUpdateTick + Settings.TicksPerUpdate
		Update()
	end
end

function OnPlayerPlacedBlock( inPlayer, inX, inY, inZ, inFace, inCursorX, inCursorY, inCursorZ, inType, inMeta)
	Bizzare.World = inPlayer:GetWorld()
	if( inType == Bizzare.Block and inMeta == Bizzare.BlockMeta ) then
		SetBlock( inX, inY, inZ, Bizzare.Block, Bizzare.Map )
	end
end

function OnPlayerBrokenBlock( inPlayer, inX, inY, inZ, inFace, inFace, inType, inMeta)
	RemoveEntry( inX, inY, inZ, Bizzare.Map	)
end